import http.client
import ssl
import xml.etree.ElementTree as ET
import json
import ziotc


context = ssl.create_default_context()
context.check_hostname = False
context.verify_mode = ssl.CERT_NONE
conn = http.client.HTTPSConnection("127.0.0.1", context=context)
payload = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<rm:command epcglobal:creationDate=\"2001-12-17T09:30:47.0Z\" epcglobal:schemaVersion=\"0.0\" xsi:schemaLocation=\"urn:epcglobal:rm:xsd:1 ../../../schemas/RmCommand.xsd\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:rm=\"urn:epcglobal:rm:xsd:1\" xmlns:epcglobal=\"urn:epcglobal:xsd:1\" xmlns:motorm=\"urn:motorfid:rm:xsd:1\">\n  <rm:id>99</rm:id>\n  <rm:targetName>MyFX9600</rm:targetName>\n  <motorm:readerDevice>\n      <motorm:doLogin>\n        <motorm:username>admin</motorm:username>\n        <motorm:password>change</motorm:password>\n        <motorm:forceLogin>true</motorm:forceLogin>\n      </motorm:doLogin>\n  </motorm:readerDevice>\n</rm:command>\n"

headers = {
   'Content-Type': 'application/xml'
}
conn.request("GET", "/control", payload, headers)
res = conn.getresponse()
data = res.read()
root = ET.fromstring(data)
session_id_value = root.find('.//{urn:motorfid:rm:xsd:1}sessionID').text
payload = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<rm:command epcglobal:creationDate=\"2001-12-17T09:30:47.0Z\"\n            epcglobal:schemaVersion=\"0.0\"\n            xsi:schemaLocation=\"urn:epcglobal:rm:xsd:1 ../../../schemas/RmCommand.xsd\"\n            xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n            xmlns:rm=\"urn:epcglobal:rm:xsd:1\"\n            xmlns:epcglobal=\"urn:epcglobal:xsd:1\"\n            xmlns:motorm=\"urn:motorfid:rm:xsd:1\">\n  <rm:id>99</rm:id>\n  <rm:targetName>MyFX7500</rm:targetName>\n  <motorm:readerDevice>\n    <motorm:sessionID>{session_id}</motorm:sessionID>\n    <motorm:cloudEndpointsMapping>\n        <motorm:operation>VIEW</motorm:operation>\n        <motorm:data></motorm:data>\n    </motorm:cloudEndpointsMapping>\n  </motorm:readerDevice>\n</rm:command>".format(session_id=session_id_value)
headers = {
  'Content-Type': 'application/xml'
}
conn.request("GET", "/control", payload, headers)
res = conn.getresponse()
data1 = res.read()
key = data1.decode('utf-8')
start = key.find('{')
end = key.rfind('}')
json_data = key[start:end+1]
parsed_data = json.loads(json_data)
type_value = parsed_data['data'][0]['type']
endpoint=type_value

payload = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><rm:command epcglobal:creationDate=\"2001-12-17T09:30:47.0Z\" epcglobal:schemaVersion=\"0.0\" xsi:schemaLocation=\"urn:epcglobal:rm:xsd:1 ../../../schemas/RmCommand.xsd\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:rm=\"urn:epcglobal:rm:xsd:1\" xmlns:epcglobal=\"urn:epcglobal:xsd:1\" xmlns:motorm=\"urn:motorfid:rm:xsd:1\"><rm:id>104</rm:id><rm:targetName></rm:targetName><motorm:readerDevice> <motorm:sessionID>{session_id}</motorm:sessionID><motorm:getReaderDetails/></motorm:readerDevice></rm:command>\n".format(session_id=session_id_value)
headers = {
   'Content-Type': 'application/xml'
}
conn.request("GET", "/control", payload, headers)
res = conn.getresponse()
data2 = res.read()
root = ET.fromstring(data2)
readername = root.find('.//{urn:motorfid:rm:xsd:1}HostName').text

payload = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><rm:command epcglobal:creationDate=\"2001-12-17T09:30:47.0Z\" epcglobal:schemaVersion=\"0.0\" xsi:schemaLocation=\"urn:epcglobal:rm:xsd:1 ../../../schemas/RmCommand.xsd\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:rm=\"urn:epcglobal:rm:xsd:1\" xmlns:epcglobal=\"urn:epcglobal:xsd:1\" xmlns:motorm=\"urn:motorfid:rm:xsd:1\"><rm:id>104</rm:id><rm:targetName></rm:targetName><motorm:readerDevice> <motorm:sessionID>{session_id}</motorm:sessionID><motorm:getNetworkInterfaceSettings><motorm:Interface>ETH</motorm:Interface></motorm:getNetworkInterfaceSettings></motorm:readerDevice></rm:command>\n".format(session_id=session_id_value)
headers = {
   'Content-Type': 'application/xml'
}
conn.request("GET", "/control", payload, headers)
res = conn.getresponse()
data3 = res.read()
root = ET.fromstring(data3)
MACAddress_element = root.find('.//{urn:motorfid:rm:xsd:1}MACAddress').text

reader_name = readername                            
mac_address = MACAddress_element                                                                         
isHeartBeat = "false" 

class tag_report:
    def __init__(self):
        self.CRC=None
        self.PC=None
        self.TID=None
        self.USER=None
        self.antenna=None
        self.channel=None
        self.eventNum=None
        self.format=None
        self.idHex=None
        self.peakRssi=None
        self.phase=None
        self.reads=None
        self.timestamp=None
        
    # for http post   
    def http_post(self):
        
        format_for_http =  {                                  
                "reader_name": reader_name,                   
                "mac_address": mac_address,                   
                "tag_reads": []                               
            }
        tag_reads = []
        tag_read = {}
    
        if self.idHex is not None:
            tag_read["epc"] = self.idHex 
        if self.PC is not None:
            tag_read["PC"] = self.PC
        if self.antenna is not None:
            tag_read["antennaport"] = self.antenna
        if self.peakRssi is not None:
            tag_read["peakrssi"] = self.peakRssi
        if self.phase is not None:
            tag_read["phase"] = self.phase
        if self.TID is not None:
            tag_read["TID"] = self.TID
        if self.USER is not None:
            tag_read["user"] = self.USER
        if self.channel is not None:
            tag_read["channel"]=self.channel
        if self.timestamp is not None:
            tag_read["timestamp"] = self.timestamp
        if self.reads is not None:
            tag_read["reads"]=self.reads
        tag_read["isHeartBeat"] = isHeartBeat
        tag_reads.append(tag_read)
        format_for_http['tag_reads'] = tag_reads
        output_json = json.dumps(format_for_http)            
        print(output_json)
        return output_json
    
    # for key value
    def key_value(self):
        
        data = {}
        if self.CRC is not None:
            data["CRC"] = self.CRC
        if self.PC is not None:
            data["PC"] = self.PC
        if self.TID is not None:
            data["TID"] = self.TID
        if self.USER is not None:
            data["USER"] = self.USER
        if self.antenna is not None:
            data["antenna"] = self.antenna
        if self.channel is not None:
            data["channel"] = self.channel
        if self.eventNum is not None:
            data["eventNum"] = self.eventNum
        if self.format is not None:
            data["format"] = self.format
        if self.idHex is not None:
            data["epc"] = self.idHex 
        if self.peakRssi is not None:
            data["peakRssi"] = self.peakRssi
        if self.phase is not None:
            data["phase"] = self.phase
        if self.reads is not None:
            data["reads"] = self.reads
        if self.timestamp is not None:
            data["timestamp"] = self.timestamp
        data["isHeartBeat"] = isHeartBeat

        return ",".join([f"{key}={value}" for key, value in data.items()])
    
    # for TCP/IP   
    def tcp_ip(self):
        
        format_for_tcpip =  {                                  
                            "mac_address": mac_address,                   
                            "tag_reads": []                               
            }
        tag_reads = []
        tag_read = {}
    
        if self.idHex is not None:
            tag_read["epc"] = self.idHex 
        if self.PC is not None:
            tag_read["PC"] = self.PC
        if self.antenna is not None:
            tag_read["antennaport"] = self.antenna
        if self.peakRssi is not None:
            tag_read["peakrssi"] = self.peakRssi
        if self.phase is not None:
            tag_read["phase"] = self.phase
        if self.TID is not None:
            tag_read["TID"] = self.TID
        if self.USER is not None:
            tag_read["user"] = self.USER
        if self.channel is not None:
            tag_read["channel"]=self.channel
        if self.timestamp is not None:
            tag_read["timestamp"] = self.timestamp
        if self.reads is not None:
            tag_read["reads"]=self.reads
        tag_read["isHeartBeat"] = isHeartBeat
        tag_reads.append(tag_read)
        format_for_tcpip['tag_reads'] = tag_reads
        output_json = json.dumps(format_for_tcpip)            
        print(output_json)
        return output_json

def new_msg_callback(msg_type, msg_in):  
    CRC=PC=TID=USER=antenna=channel=eventNum=format=idHex=peakRssi=phase=reads=timestamp=None
    if msg_type == ziotc.ZIOTC_MSG_TYPE_TAG_INFO_JSON:
        msg_in_json = json.loads(msg_in.decode('utf-8'))
        
        msg = tag_report()
        
        data=msg_in_json["data"]
        
        
        if 'CRC' in data:
            msg.CRC = data["CRC"] 
        if 'PC' in data:
           msg.PC = data["PC"]
        if 'TID' in data:
            msg.TID = data["TID"]
        if 'USER' in data:
            msg.USER = data["USER"]
        if 'antenna' in data:
           msg.antenna = data["antenna"]
        if 'channel' in data:
            msg.channel = data["channel"]
        if 'eventNum' in data:
            msg.eventNum = data["eventNum"]
        if 'format' in data:
            msg.format = data["format"]
        if 'idHex' in data:
            msg.idHex = data["idHex"]
        if 'peakRssi' in data:
            msg.peakRssi = data["peakRssi"]
        if 'phase' in data:
            msg.phase = data["phase"]
        if 'reads' in data:
            msg.reads= data["reads"]
        if 'timestamp' in msg_in_json:
            msg.timestamp = msg_in_json["timestamp"]
        isHeartBeat = "false"
    if endpoint=='HTTP-POST':
        output_json=msg.http_post()
        message_bytearray = bytearray(output_json.encode('utf-8'))
        ziotcObject.send_next_msg(ziotc.ZIOTC_MSG_TYPE_DATA, message_bytearray)
    elif endpoint=='KEYBOARD-EMULATION':  
        kv_str = msg.key_value()
        ziotcObject.send_next_msg(ziotc.ZIOTC_MSG_TYPE_DATA, bytearray(msg.key_value().encode('utf-8')))


    elif endpoint=='TCPIP-SERVER':
        output_json=msg.tcp_ip()
        message_bytearray = bytearray(output_json.encode('utf-8'))
        ziotcObject.send_next_msg(ziotc.ZIOTC_MSG_TYPE_DATA, message_bytearray) 
        ziotcObject.send_next_msg(ziotc.ZIOTC_MSG_TYPE_DATA, output_json.encode('utf-8'))
    
    
ziotcObject = ziotc.ZIOTC()                                   
ziotcObject.reg_new_msg_callback(new_msg_callback)            
ziotcObject.loop.run_forever()
    
    
        
        
